unit RGPanel;
{-----------------------------------------------------------------------------
RGPanel version 1.0  for Delphi
CopyRight(c) 2003 by Aldo Radesic, Slovenija
Feel free to contact me if you have any questions, comments or suggestions
at aldo.radesic@siol.net
This component is FREEWARE.
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Files needed to install:
RGPanel.pas (this file)        
-----------------------------------------------------------------------------}

interface

uses
Messages,Windows,SysUtils, Classes, Controls, ExtCtrls;
type
  TFloatingPanel= (fpSelf,fpNone,fpParent);
type
  TRGPanel = class(TPanel)
  private
    FFloatingPanel: TFloatingPanel;
    procedure SetFloatingPanel(Value: TFloatingPanel);
    function  GetFloatingPanel:TFloatingPanel;
  protected
    procedure MouseDown(Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer); override;
  public
    { Public declarations }
  published
    property FloatingPanel: TFloatingPanel read GetFloatingPanel write SetFloatingPanel default fpSelf;
  end;

procedure Register;

implementation
procedure TRGPanel.MouseDown(Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
const
   SC_DragMove = $F012;
begin
  inherited
    MouseDown(Button, Shift, X, Y);
    if (Button=mbLeft) and (FloatingPanel<>fpNone) then
  begin
     ReleaseCapture;
    if FloatingPanel=fpParent then
     Parent.Perform(WM_SysCommand, SC_DragMove, 0)
      else
     Perform(WM_SysCommand, SC_DragMove, 0);
    Invalidate;
  end;
end;

procedure TRGPanel.SetFloatingPanel(Value: TFloatingPanel);
begin
    FFloatingPanel:= Value;
    Invalidate;
end;

function  TRGPanel.GetFloatingPanel:TFloatingPanel;
begin
  Result := FFloatingPanel;
end;

procedure Register;
begin
  RegisterComponents('RGLogic', [TRGPanel]);
end;

end.

