{
 @Author(Nathanal VERON <r.b.a.g@free.fr>)
 @Created(25/02/2003)
 @Abstract(La TRbAdvComboBox est une ComboBox multi-colonne disposant de nombreuses proprits graphiques supplmentaires...)

 TODO : Make a property editor for the values...

 You can use this component as freeware for you non-commercial applications. In
 other cases, contact me : r.b.a.g@free.fr . It's also valid to report bugs or
 ask for additional features.

}
unit RbAdvComboBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, variants,
  StdCtrls, StrUtils, Dialogs;

type
  //Forward declarations;
  TRbColumn = class;
  TRbColumns = class;
  TRbAdvComboBox = class;

  PVariantArray = ^TVariantArray;
  TVariantArray = array of PVariant;
  TVariantMatrix = array of PVariantArray;

  TRbColumns = class(TOwnedCollection)
  private
    function GetItem(Index: integer): TRbColumn;
    procedure SetItem(Index: integer; const Value: TRbColumn);
  protected

  public
    constructor Create(Combo : TRbAdvComboBox);
    procedure EndUpdate; override;
    function Add : TRbColumn;
    property Items[Index : integer]: TRbColumn read GetItem write SetItem; default;
  end;

  TRbColumn = class(TCollectionItem)
  private
    FAlignement : TAlignment;
    FAutoWidth : boolean;
    FColor1 : TColor;
    Fcolor2 : TColor;
    FisGradient : boolean;
    FFont : TFont;
    FVisible : boolean;
    FTag : integer;
    FWidth : integer;
    FIsImageIndex : boolean;
    procedure SetAlignement(const Value: TAlignment);
    procedure SetAutoWidth(const Value: boolean);
    procedure SetFont(const Value: TFont);
    procedure SetVisible(const Value: boolean);
    procedure SetWidth(const Value: integer);
    procedure FontChanged(Sender : TObject);
    procedure SetIsImageIndex(const Value: boolean);
  protected

  public
    constructor Create(Collection : TCollection); override;
    destructor Destroy; override;
  published
    property Alignement : TAlignment read FAlignement write SetAlignement;  
    property AutoWidth : boolean read FAutoWidth write SetAutoWidth;
    property Color1 : TColor read FColor1 write FColor1;
    property Color2 : TColor read FColor2 write FColor2;
    property Font : TFont read FFont write SetFont;
    property Visible : boolean read FVisible write SetVisible;
    property Tag : integer read FTag write FTag;
    property Width : integer read FWidth write SetWidth;
    property IsImageIndex : boolean read FIsImageIndex write SetIsImageIndex;
    property IsGradient : boolean read FIsGradient write FIsGradient;
  end;


  TRbAdvComboBox = class(TCustomComboBox)
  private
    FItems : TVariantMatrix;
    FSelectionColor : TColor;
    FSelectionFontColor : TColor;
    FSortedCol : integer;
    FSorted : boolean;
    FLookupKey : boolean;
    FLookupCol : integer;
    FOnKeyPress: TKeyPressEvent;
    FLookChar : Char;
    FRbColumns : TRbColumns;
    FDropDownWidth: integer;
    FOnDropDown : TNotifyEvent;
    FImageList : TImageList;
    FDisplayColumn : integer;
    FDropDownAutoWidth: boolean;
    function GetItem(ARow, ACol: integer): Variant;
    function GetItemText(ARow, ACol: integer): string;
    procedure SetItem(ARow, ACol: integer; const Value: Variant);
    function GetMaxColWidth(ACol : integer): integer;
    function GetSelText(ACol: integer): String;
    procedure SetSortedCol(const Value: integer);
    procedure Sort;
    procedure SelfKeyPress(Sender: TObject; var Key: Char);
    procedure SetSorted(const Value: boolean);
    procedure SetLookupCol(const Value: integer);
    procedure IncSearch(Key : Char);
    procedure SetColumns(const Value: TRbColumns);
    function GetColCount: integer;
    procedure SetColCount(const Value: integer);
    procedure SetDropDownWidth(const Value: integer);
    procedure SelfDropDown(Sender: TObject);
    procedure SetDisplayColumn(const Value: integer);
    procedure DoGradient(CurrRect : TRect; Color1, Color2 : TColor);

  protected 
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    function GetItemCount : integer; override;
  public
    constructor Create(AOwner : TComponent); override;
    Destructor Destroy; override;
    function AddItem(AValues : array of Variant): integer;
    function AddRow : integer;
    procedure DeleteRow(AIndex : integer);
    procedure DeleteSelected;
    procedure Clear;
    property Items[ARow, ACol : integer] : Variant read GetItem write SetItem;
    property SelText[ACol : integer] : String read GetSelText;
    property ItemCount : integer read GetItemCount;
  published

    {$IFNDEF Delphi5}
    property Anchors;
    property Constraints;
    property DragKind;
    {$ENDIF}
    property AutoDropDown default False;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BiDiMode;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property ImeMode;
    property ImeName;
    property ItemIndex default -1;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnClick;
    property OnCloseUp;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown: TNotifyEvent read FOnDropDown write FOnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyPress : TKeyPressEvent read FOnKeyPress write FOnKeyPress;
    property OnKeyDown;
    property OnKeyUp;
    property OnSelect;
    property OnStartDock;
    property OnStartDrag;

    //Added properties
    property ColCount : integer read GetColCount write SetColCount;
    property SelectionColor : TColor read FSelectionColor write FSelectionColor;
    property SelectionFontColor : TColor read FSelectionFontColor write FSelectionFontColor;
    property Sorted : boolean read FSorted write SetSorted;
    property SortedCol : integer read FSortedCol write SetSortedCol;
    property LookupKey : boolean read FLookupKey write FLookupKey;
    property LookupCol : integer read FLookupCol write SetLookupCol;
    property Columns : TRbColumns read FRbColumns write SetColumns;
    property DropDownWidth : integer read FDropDownWidth write SetDropDownWidth;
    property Images : TImageList read FImageList write FImageList;
    property DisplayColumn : integer read FDisplayColumn write SetDisplayColumn;
    property DropDownAutoWidth : boolean read FDropDownAutoWidth write FDropDownAutoWidth;
  end;

procedure Register;

implementation

{$B-}

uses Types;

//Strings
const
  sTableauTailleDif ='La liste des lments doit contenir'+sLineBreak+'le mme nombre d''lments que le composant';
  sTypeIncompatible ='Les lments doivent tre de type numrique ou chane';
//-------

procedure Register;
begin
  RegisterComponents('RbControls', [TRbAdvComboBox]);
end;


//--------------------------------------------
// TRbColumn
//--------------------------------------------

constructor TRbColumn.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FAlignement := taLeftJustify;
  FAutoWidth := True;
  FColor1 := clWindow;
  FColor2 := clSilver;
  FIsGradient := false;
  FVisible := True;
  FFont := TFont.Create;
  FFont.OnChange := FontChanged;
  FWidth := 0;
  FIsImageIndex := false;
end;


destructor TRbColumn.Destroy;
begin
  FFont.Free;
  inherited;  
end;

procedure TRbColumn.FontChanged(Sender: TObject);
begin
  Collection.EndUpdate;
end;

procedure TRbColumn.SetAlignement(const Value: TAlignment);
begin
  FAlignement := Value;
end;

procedure TRbColumn.SetAutoWidth(const Value: boolean);
begin
  if not IsImageIndex then
    FAutoWidth := Value;
end;

procedure TRbColumn.SetFont(const Value: TFont);
begin
  FFont.Assign(Value);
end;

procedure TRbColumn.SetIsImageIndex(const Value: boolean);
begin
  FIsImageIndex := Value;
  if Value then FAutoWidth := False;
end;

procedure TRbColumn.SetVisible(const Value: boolean);
begin
  FVisible := Value;
end;

procedure TRbColumn.SetWidth(const Value: integer);
begin
  if Value < 0 then
    FWidth := 0
  else
    FWidth := Value;
end;

//--------------------------------------------
// TRbColumns
//--------------------------------------------

function TRbColumns.Add: TRbColumn;
begin
  Result := TRbColumn(inherited Add);
end;

constructor TRbColumns.Create(Combo: TRbAdvComboBox);
begin
  inherited Create(Combo, TRbColumn);
end;

procedure TRbColumns.EndUpdate;
var
  i, maxheight: integer;
begin
  inherited;
  with TRbAdvComboBox(Owner) do
  begin
    MaxHeight := 0;
    //Set the items Height to the max column font height
    for i:= 0 to FRbColumns.Count-1 do
      if Abs(FRbColumns[i].FFont.Height) > MaxHeight then
        MaxHeight := Abs(FRbColumns[i].FFont.Height);

    ItemHeight := MaxHeight  + 4;
  end;
end;

function TRbColumns.GetItem(Index: integer): TRbColumn;
begin
  Result := TRbColumn(inherited GetItem(Index));
end;


procedure TRbColumns.SetItem(Index: integer; const Value: TRbColumn);
begin
  inherited SetItem(Index, Value);
end;

//--------------------------------------------
// TRbAdvComboBox
//--------------------------------------------

//Add a row to the ComboBox & returns the index of the new row
function TRbAdvComboBox.AddRow: integer;
var
  PV : PVariantArray;
  Size : integer;
begin
  Size := Length(FItems);
  New(PV);
  SetLength(PV^, FRbColumns.Count);
  SetLength(FItems, Size +1);
  FItems[Size] := PV;
  Result := Size;
  SendMessage(Handle, CB_ADDSTRING, 0, LongInt(PChar('')));
end;

constructor TRbAdvComboBox.Create(AOwner: TComponent);
begin
  inherited;
  FRbColumns := TRbColumns.Create(Self);
  FRbColumns.Add;
  FRbColumns.Add;
  Style := csOwnerDrawFixed;
  FSelectionColor := clHighlight;
  FSelectionFontColor := clWhite;
  FSortedCol := 0;
  FSorted := False;
  FLookupKey := False;
  FLookupCol := 0;
  FOnKeyPress := nil;
  FOnDropDown := nil;
  FLookChar := #0;
  FDisplayColumn := -1;
  inherited OnDropDown := SelfDropDown;
  inherited OnKeyPress := SelfKeyPress;
end;

//Delete a row from the combo
procedure TRbAdvComboBox.DeleteRow(AIndex: integer);
var
 i, Size : integer;
begin
  if (AIndex >= Length(FItems)) or (AIndex < 0) then Exit;

  Size := Length(FItems);

  for i:= 0 to FRbColumns.Count-1 do
  begin
   if FItems[AIndex]^[i] <> nil then
      Dispose(FItems[AIndex]^[i]);
  end;
  SetLength(FItems[AIndex]^, 0);
  Dispose(FItems[AIndex]);

  for i := AIndex to Size-2 do
  begin
    FItems[i] := FItems[i+1] ;
  end;
  SetLength(FItems, Size-1);
  SendMessage(Handle, CB_DELETESTRING, AIndex, 0);
end;

destructor TRbAdvComboBox.Destroy;
var
  i, j : integer;
begin
  for i:=0 to Length(FItems)-1 do
  begin
    for j:=0 to FRbColumns.Count-1 do
    begin
      if FItems[i]^[j] <> nil then
        Dispose(FItems[i]^[j]);
    end;
    Dispose(FItems[i]);
  end;
  SetLength(FItems, 0);

  FRbColumns.Free;
  inherited;
end;

procedure TRbAdvComboBox.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
var
  i,Size,TotalWidth : integer;
  CurrRect : TRect;
  DrawFlags : integer;
begin
  TotalWidth := 0;
  DrawFlags := 0;
  if (odSelected in State) then
  begin
    Canvas.Brush.Color:= FSelectionColor;
    Canvas.FillRect(Rect);
  end;
  
  if (odComboBoxEdit in State) and (DisplayColumn >= 0) then
  begin
    //Draw one column in the Edit if DisplayColumn is set
    Canvas.Font.Assign(FRbColumns.Items[DisplayColumn].Font);
    if not (odSelected in State) then
      if FRbColumns.Items[DisplayColumn].IsGradient then
        DoGradient(Rect, FRbColumns.Items[DisplayColumn].Color1, FRbColumns.Items[DisplayColumn].Color2);

    DrawTextEx(Canvas.Handle, PChar(GetItemText(Index, DisplayColumn)), Length(GetItemText(Index, DisplayColumn)), Rect, DrawFlags or DT_END_ELLIPSIS, nil);
  end else begin
    //Draw all the columns
    for i:=0 to FRbColumns.Count-1 do
    begin
      //Do not draw if invisible col 
      if (not FRbColumns.Items[i].Visible)  then Continue;

      if FRbColumns.Items[i].FAutoWidth then
        Size := GetMaxColWidth(i) + 8
      else
        Size := FRbColumns.Items[i].Width;

      CurrRect := Classes.Rect(Rect.Left+TotalWidth,Rect.Top,Rect.Left+TotalWidth+Size,Rect.Bottom);

      if i = (FRbColumns.Count - 1) then CurrRect.Right := Rect.Right;

      Canvas.Font.Assign(FRbColumns.Items[i].Font);

      if not (odSelected in State) then
      begin
        if (FRbColumns.Items[i].IsGradient) then
          DoGradient(CurrRect, FRbColumns.Items[i].Color1, FRbColumns.Items[i].Color2)
        else begin
          Canvas.Brush.Color := FRbColumns.Items[i].FColor1;
          Canvas.FillRect(CurrRect);
        end;
      end else begin
        Canvas.FillRect(CurrRect);
        Canvas.Font.Color := FSelectionFontColor;
      end;

      if FRbColumns.Items[i].IsImageIndex and (Images <> nil) then
      begin
        //Draw the image
        if (FItems[index]^[i]^ <> null) and  VarIsNumeric(FItems[index]^[i]^)
            and (FItems[index]^[i]^ < FImageList.Count) then
              FImageList.Draw(Canvas,CurrRect.Left, CurrRect.Top, FItems[index]^[i]^);

      end else
      begin
        DrawFlags := DT_VCENTER;
        if FRbColumns.Items[i].Alignement = taLeftJustify then
          DrawFlags := DrawFlags or DT_LEFT;
        if FRbColumns.Items[i].Alignement = taRightJustify then
          DrawFlags := DrawFlags or DT_RIGHT;
        if FRbColumns.Items[i].Alignement = taCenter then
          DrawFlags := DrawFlags or DT_CENTER;
       OffsetRect(CurrRect, 0, 1);
       SetBkMode(Canvas.Handle, TRANSPARENT);
       DrawTextEx(Canvas.Handle, PChar(GetItemText(Index, i)), Length(GetItemText(Index, i)), CurrRect, DrawFlags or DT_END_ELLIPSIS, nil);
      end;
      Inc(TotalWidth, Size);
    end;
  end;  
end;

function TRbAdvComboBox.GetItemCount: integer;
begin
  Result := Length(FItems);
end;

function TRbAdvComboBox.GetItem(ARow, ACol: integer): Variant;
begin
  Result := null;
  if (ACol >= FRbColumns.Count) or (ARow >= Length(FItems))
      or (ACol < 0 ) or (ARow < 0) then Exit;

  if FItems[ARow]^[ACol] <> nil then Result := FItems[ARow]^[ACol]^;
end;

procedure TRbAdvComboBox.SetColCount(const Value: integer);
var
  i,OldColCount : integer;
begin
  if (Value < 1) or (FRbColumns.Count = Value) then Exit;
  try
    FRbColumns.BeginUpdate;
    for i:= 0 to Length(FItems)-1 do
    begin
      SetLength(FItems[i]^, Value);
    end;
    OldColCount := FRbColumns.Count;
    if (OldColCount - Value)  < 0  then
    begin
      for i:=1 to  (Value - OldColCount) do
        FRbColumns.Add;
    end else begin
      for i:=1 to (OldColCount - Value) do
        FRbColumns.Delete(OldColCount-i);
    end;
  finally
    FRbColumns.EndUpdate;
  end;

  Invalidate;
end;

procedure TRbAdvComboBox.SetItem(ARow, ACol: integer; const Value: Variant);
var
  PV : PVariant;
begin
  if (ACol >= FRbColumns.Count) or (ARow >= Length(FItems))
      or (ACol < 0 ) or (ARow < 0) then Exit;

  if not (VarIsNumeric(Value) or VarIsStr(Value) or VarIsType(Value, VarBoolean)) then
    raise Exception.Create(sTypeIncompatible);
        
  if FItems[ARow]^[ACol] <> nil then
    FItems[ARow]^[ACol]^:= Value
  else begin
    new(PV);
    PV^ := Value;
    FItems[ARow]^[ACol] := PV;
  end;
end;

//Returns the col max width in pixel
function TRbAdvComboBox.GetMaxColWidth(ACol: integer): integer;
var
  i, Size, CSize, Index : integer;
begin
  Result := 0;
  if (ACol < 0) or (ACol >= FRbColumns.Count) then Exit;
  Size := 0;

  for i:= (ItemCount - 1) downto 0 do
  begin
    if FItems[i]^[ACol] = nil then Continue;
    CSize := Length(FItems[i]^[ACol]^);
    if CSize > Size then begin
      Size := CSize;
      Index := i;
    end;
  end;
  Canvas.Font := FRbColumns.Items[ACol].Font;
  Result := Canvas.TextWidth(FItems[Index]^[ACol]^);
end;

//Add row at the end of the combo and returns its index
function TRbAdvComboBox.AddItem(AValues: array of Variant): integer;
var
  i, Index: integer;
begin
  if Length(AValues) <> FRbColumns.Count then
    raise Exception.Create(sTableauTailledif);
  Index := AddRow;
  for i:=0 to FRbColumns.Count-1 do
  begin
    try
      Items[Index, i] := AValues[i]
    except
      DeleteRow(i);
    end;
  end;
  Result := Index;
  Sort;
end;

function TRbAdvComboBox.GetSelText(ACol: integer): String;
begin
  Result := '';
  if ItemIndex < 0 then Exit;
  Result := GetItemText(ItemIndex, ACol);
end;

//Delete selected row
procedure TRbAdvComboBox.DeleteSelected;
begin
  if ItemIndex < 0 then Exit;
  DeleteRow(ItemIndex);
end;

procedure TRbAdvComboBox.SetSortedCol(const Value: integer);
begin
  if (Value >= FRbColumns.Count) or (Value < 0) then
  begin
    FSortedCol := FRbColumns.Count-1;
    Exit;
  end;
  FSortedCol := Value;
  Sort;
end;

procedure TRbAdvComboBox.Sort;

        procedure SwapV(var A, B: PVariantArray);
        var
          PV : PVariantArray;
        begin
          PV := A;
          A := B;
          B := PV;
        end;

        procedure DoSort(S, E :Integer);
        var
          lo,hi :Integer;
          Mid : string;
        begin
          Mid:= GetItemText((S + E) div 2, FSortedCol);
          lo := S;
          hi := E;
          repeat
            while GetItemText(lo, FSortedCol) < Mid do Inc(lo);
            while GetItemText(hi, FSortedCol) > Mid do Dec(hi);

            if lo <= hi then begin
              SwapV( FItems[lo], FItems[hi] );
              Inc(lo);
              Dec(hi);
            end;
          until lo > hi;

          if hi > S then DoSort(S, hi);
          if lo < E then DoSort(lo, E);
        end;
begin
  if not FSorted then Exit;
  //QSort
  DoSort(Low(FItems),High(FItems));
end;

procedure TRbAdvComboBox.SelfKeyPress(Sender: TObject; var Key: Char);
begin
  //Incrmental search (1 char for the moment, not implemented)
  if FLookupKey and Sorted then IncSearch(Key);

  if Assigned(FOnKeyPress) then FOnKeyPress(Sender, Key);
end;

procedure TRbAdvComboBox.SetSorted(const Value: boolean);
begin
  FSorted := Value;
  Sort;
end;

procedure TRbAdvComboBox.SetLookupCol(const Value: integer);
begin
  if (Value < 0) or (Value > (FRbColumns.Count-1)) then Exit;
  FLookupCol := Value;
end;

procedure TRbAdvComboBox.IncSearch(Key: Char);
var
  i : integer;
  S : string;
begin
 for i:=0 to ItemCount-1 do
 begin
   S := GetItemText(i, FLookupCol);
   if Length(S) < 1 then Continue;
   if S[1] >= Key then
   begin
     ItemIndex := i;
     Break;
   end;
 end;
end;

function TRbAdvComboBox.GetItemText(ARow, ACol: integer): string;
var
  v : variant;
begin
  v := GetItem(ARow, ACol);
  if v = null then
    Result := ''
  else
   Result := v;
end;

function TRbAdvComboBox.GetColCount: integer;
begin
  Result := FRbColumns.Count;
end;

procedure TRbAdvComboBox.SetColumns(const Value: TRbColumns);
begin
  try
    FRbColumns.BeginUpdate;
    FRbColumns.Assign(Value);
  finally
    FRbColumns.EndUpdate;
  end;
end;

procedure TRbAdvComboBox.SetDropDownWidth(const Value: integer);
begin
  FDropDownWidth := Value;
end;

procedure TRbAdvComboBox.SelfDropDown(Sender: TObject);
var
  i : integer;
  TotW : integer;
begin

  if not DropDownAutoWidth then
    if FDropDownWidth > 0 then
      Perform(CB_SETDROPPEDWIDTH, FDropDownWidth, 0)
    else
      Perform(CB_SETDROPPEDWIDTH, Width, 0)
  else begin
    //Set the size of the drop down to the size of the elements (could be hazardous)
    TotW := 0;
    for i := 0 to FRbColumns.Count - 1 do
      Inc(TotW, GetMaxColWidth(i) + 14);
    Perform(CB_SETDROPPEDWIDTH, TotW, 0);
  end;

  if Assigned(FOnDropDown) then FOnDropDown(Sender);
end;

procedure TRbAdvComboBox.SetDisplayColumn(const Value: integer);
begin
  if (Value <> FDisplayColumn) and (Value < FRbColumns.Count) and (Value > -2) then begin
    FDisplayColumn := Value;
    Invalidate;
  end;
end;

procedure TRbAdvComboBox.Clear;
var
  i : integer;
begin
  for i := GetItemCount - 1 downto 0 do DeleteRow(i);
end;

procedure TRbAdvComboBox.DoGradient(CurrRect: TRect; Color1, Color2: TColor);
var
  Dep : array[0..2] of integer;
  Dif : array[0..2] of Double;
  i : integer;
begin
  Dep[0] := GetRValue(ColorToRGB(Color1));
  Dep[1] := GetGValue(ColorToRGB(Color1));
  Dep[2] := GetBValue(ColorToRGB(Color1));

  Dif[0] := (GetRValue(ColorToRGB(Color2)) - Dep[0]) / (CurrRect.Right - CurrRect.Left);
  Dif[1] := (GetGValue(ColorToRGB(Color2)) - Dep[1]) / (CurrRect.Right - CurrRect.Left);
  Dif[2] := (GetBValue(ColorToRGB(Color2)) - Dep[2]) / (CurrRect.Right - CurrRect.Left);

  if Dif[0] > 255 then Dif[0] := 255;
  if Dif[1] > 255 then Dif[1] := 255;
  if Dif[2] > 255 then Dif[2] := 255;

  for i := CurrRect.Left to CurrRect.Right do begin
    Canvas.Pen.Color := RGB( Round(Dep[0] + (Dif[0] * (i - CurrRect.Left))), Round(Dep[1] + (Dif[1] * (i - CurrRect.Left))), Round(Dep[2] + (Dif[2] * (i - CurrRect.Left))));
    Canvas.MoveTo(i, CurrRect.Top);
    Canvas.LineTo(i, CurrRect.Bottom);
  end;
end;


end.
